function [theta,fval,Gradient,Hessian]=BFGS(fun,theta0)

% ĹBFGS㷨Ŀ꺯f()ֵ
% ûҪṩĿ꺯
% 㷨Զֵݶ躣Ϣ

% fun       Ŀ꺯ľ
% theta0    ȵĳʼֵd*1
% theta     Ŀ꺯Ħֵ
% fval      Ŀ꺯ֲֵ
% Gradient  ŵֵݶ
% Hessian   ŵֵĺ

% עĿ꺯ɲfunΪ
%     @(theta) myfun(theta, other_para)
%     ȻĿ꺯еҲͨǶȫֱʵ
%     򵥵Ľ

% ߣ Ǯ Hang Qian, Iowa State University
%            3373126@gmail.com
%--------------------------------------------


% õ
% max_iter:   tolȣ   deltaֵС
% line_search: Ӧ,ӰٶȣӰ쾫ȣ
% method_switch: mε󣬴ӾȷתΪȷ
% max_attempt: Ӧ򲻾ȷ
% ע: line_search,method_switch,max_attemptԵٶӰش趨
%     ʱӦⶨӺ INEXACT_LINE_SEARCH
max_iter=200;  
tol=1e-14;
delta=1e-6;
line_search=2.^(-15:-5);
method_switch=10;
max_attempt=20;
theta=theta0;
ndim=length(theta);

% ûṩĿ꺯ͳʼֵ
[nrow,ncol]=size(theta0);
if nrow==1 && ncol>1
    theta=theta';
end

try 
    fval=fun(theta);
catch
    disp('Error in objective functions')
    fval=fun(theta);
end

[nrow,ncol]=size(fval);
if ~isscalar(fval)
    error(['Error: should be a scalar ',...
         num2str(nrow),'*',num2str(ncol)])
end

    
% м
iota=eye(ndim)*delta;
A=eye(ndim);

%------------------Ĵ뿪ʼ-----------------
% ʼBFGS
[fval,Gradient]=FUN_GRAD(theta,fun);
for m=1:max_iter
    
    disp(' ')
    disp(['Iteration  ',num2str(m),' in progress:']) 
    
    % ݱ
    theta_temp=theta;
    fval_temp=fval;
    Gradient_temp=Gradient;
    
    % ̽ɸѡŵԱ,Ŀ꺯ֵݶ
    if m < method_switch
        [theta,fval,Gradient,line_search]=EXACT_LINE_SEARCH(fun,theta,fval,Gradient,A,max_attempt,line_search);
    else
        [theta,fval,Gradient]=INEXACT_LINE_SEARCH(fun,theta,fval,Gradient,A,max_attempt);
    end
         
    % ¾ A
    % A ڽƸ󣬹´ʹ
    D_theta=theta-theta_temp;
    D_Grad=Gradient-Gradient_temp;
    temp1=D_theta'*D_Grad;
    temp2=eye(ndim)-D_Grad*D_theta'/temp1;
    A=temp2'*A*temp2-D_theta*D_theta'/temp1;
        
    disp(['= ',num2str(theta')])  
    disp(['Function value: ',num2str(fval)])
    
    resid1=theta-theta_temp;
    resid2=abs(fval-fval_temp);
    if resid1'*resid1<tol && resid2<1e-2
        disp(' ')
        disp(['Congratulations,after ',num2str(m),' iterations, converged!'])
        break
    end
end

% ûҪṩŵֵֵ
if nargout>3      
    fval_change=Gradient*delta+fval;
    delta_sq=delta^2;
    Hessian=zeros(ndim,ndim);
    for d1=1:ndim
        Hessian(d1,d1)=(fun(theta+2*iota(:,d1))-2*fval_change(d1)+fval)/delta_sq;
        for d2=1:d1-1
            Hessian(d1,d2)=(fun(theta+iota(:,d1)+iota(:,d2))-fval_change(d1)-fval_change(d2)+fval)/delta_sq;
            Hessian(d2,d1)=Hessian(d1,d2);
        end   
    end    
end


end

% 
%--------------------------



%-------------------------
% Ӻ EXACT_LINE_SEARCH
%-------------------------
function [theta_update,fval_update,Gradient_update,line_search]=EXACT_LINE_SEARCH(fun,theta,fval,Gradient,A,max_attempt,line_search)

nline=length(line_search);
fval_benchmark=fval;
fval_cand=zeros(nline,1);

D_theta_part=A*Gradient; 
for k=1:nline
    D_theta=line_search(k)*D_theta_part; 
    theta_cand=theta+D_theta;
    fval_cand(k)=fun(theta_cand);
end
[fval_update,index]=max(fval_cand);
            
if index==1 
    for r=1:max_attempt
        line_search=line_search/2;        
        disp(['Line search step shrinking[',rats(line_search(1)),' , ',rats(line_search(end)),' ]'])
        fval=fun(theta+line_search(1)*D_theta_part);
        if fval < fval_update
            index=2;            
            break
        else
            fval_update=fval;
        end
    end
end
        
if index==nline    
    for r=1:max_attempt
        line_search=line_search*2;        
        disp(['Line search step magnifying[',rats(line_search(1)),' , ',rats(line_search(end)),' ]'])                             
        fval=fun(theta+line_search(end)*D_theta_part);
        if fval < fval_update
            index=nline-1;            
            break
        else
            fval_update=fval;
        end
    end
end 

lambda=line_search(index);
if fval_update>=fval_benchmark    
    disp(['Line search successful, Step size:  = ',num2str(lambda)])    
else
   lambda=min(lambda,1e-10);
   disp(['Line search failed, Step size: = ',num2str(lambda)])   
end

D_theta=lambda*D_theta_part; 
theta_update=theta+D_theta;
[fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval_update);

end


%---------------------------
% Ӻ INEXACT_LINE_SEARCH
% ע޽ʱɱ̫ߣv3.1汾
%---------------------------
function [theta_update,fval_update,Gradient_update]=INEXACT_LINE_SEARCH(fun,theta,fval,Gradient,A,max_attempt)

c1=1e-4;
D_theta_part=A*Gradient;
AG=D_theta_part;
GAG=Gradient'*AG;

% Wolfe(Armijo)ֵܲ
lambda1=1;
theta_update=theta+lambda1*D_theta_part;
fval1=fun(theta_update);
Armijo = fval1 > fval+c1*lambda1*GAG; 

if Armijo 
    disp(['Ideal step size :  = ',num2str(lambda1)])
    [fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval1);
    return
end

% öκĿ꺯ѰŲ
% ٴβWolfe(Armijo),ֵܲ
lambda2=-0.5*GAG*lambda1^2/(fval1-GAG*lambda1-fval); 
theta_update=theta+lambda2*D_theta_part;
fval2=fun(theta_update);
Armijo = fval2 > fval+c1*lambda2*GAG; 

if Armijo
    disp(['Ideal step size(Quadratics):  = ',num2str(lambda2)])
    [fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval2);
    return
end

% κĿ꺯ѰŲ
% ٴβWolfe(Armijo),ֵܲ
if lambda2>0
    coeff=1/((lambda1*lambda2)^2*(lambda1-lambda2))...
        *[lambda2^2,-lambda1^2;-lambda2^3,lambda1^3]...
        *[fval1-GAG*lambda1-fval;fval2-GAG*lambda2-fval];
    a=coeff(1);
    b=coeff(2);
    lambda3=(-b-sqrt(b^2-3*a*GAG))/(3*a);
    theta_update=theta+lambda3*D_theta_part;
    fval3=fun(theta_update);
    Armijo = fval3 > fval+c1*lambda3*GAG;    

    if Armijo 
        disp(['Ideal step size(Cubic I):  = ',num2str(lambda3)])
        [fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval3);
        return
    end
else
    lambda3=0;
    fval3=-inf;    
end

% һκĿ꺯ѰŲ
% ٴβWolfe(Armijo+Curvature),ֵܲ
if lambda2>0 && lambda3>0
    coeff=1/((lambda2*lambda3)^2*(lambda2-lambda3))...
        *[lambda3^2,-lambda2^2;-lambda3^3,lambda2^3]...
        *[fval2-GAG*lambda2-fval;fval3-GAG*lambda3-fval];
    a=coeff(1);
    b=coeff(2);
    lambda4=(-b-sqrt(b^2-3*a*GAG))/(3*a);
    theta_update=theta+lambda4*D_theta_part;
    fval4=fun(theta_update);
    Armijo = fval4 > fval+c1*lambda4*GAG;    

    if Armijo
        disp(['Ideal step size(Cubic II):  = ',num2str(lambda4)])
        [fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval4);
        return
    end
else
    lambda4=0;
    fval4=-inf;    
end


% Уö԰ַⲽ
lambda_hist=0.5.^(1:max_attempt);
fval_hist=zeros(1,max_attempt);
for r=1:max_attempt
    lambda=lambda_hist(r);
    theta_update=theta+lambda*D_theta_part;
    fval_update=fun(theta_update);
    fval_hist(r)=fval_update;    
    Armijo = fval_update > fval+c1*lambda*GAG;
    
    if Armijo
        disp(['Ideal step size(Half):  = ',num2str(lambda)])
        [fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval_update);
        return    
    end    
end

% ɽˮ
lambda_all=[lambda1,lambda2,lambda3,lambda4,lambda_hist];
fval_all=[fval1,fval2,fval3,fval4,fval_hist];

valid_index=lambda_all>0;
lambda_all=lambda_all(valid_index);
fval_all=fval_all(valid_index);

[fval_update,index]=max(fval_all);
lambda=lambda_all(index);
theta_update=theta+lambda*D_theta_part;
[fval_update,Gradient_update]=FUN_GRAD(theta_update,fun,fval_update);

disp(['Ideal step size search failed:  = ',num2str(lambda)])

end


%---------------------------
% Ӻ FUN_GRAD
% ûĿ꺯ֵ
%---------------------------
function [fval,Gradient]=FUN_GRAD(theta,fun,fval)

if nargin<3
    fval=fun(theta);
end

delta=1e-6;
ndim=length(theta);
iota=eye(ndim)*delta;
fval_change=zeros(ndim,1);

for n=1:ndim        
    fval_change(n)=fun(theta+iota(:,n));    
end 
Gradient=(fval_change-fval)/delta;

end
